<template>
  <div class="d-inline">
    <v-menu bottom min-width="200px" rounded offset-y>
      <template #activator="{ on }">
        <v-btn
          large
          text
          :color="
            $store.getters['brand/getAvatarTextColor']
              ? $store.getters['brand/getAvatarTextColor']
              : 'white'
          "
          :class="[
            'subtitle-2',
            'text-none',
            'font-poppins',
            'text-left',
            { 'py-8': withPadding },
            { 'px-0': !withPadding },
          ]"
          v-on="on"
        >
          <v-avatar color="primary" size="45" class="mr-3">
            <img v-if="user.picture" :src="user.picture" />
            <span v-else-if="user.first_name" class="white--text text-h6">{{
              user.first_name.charAt(0) + user.last_name.charAt(0)
            }}</span>
          </v-avatar>
          <span v-if="$store.getters['authconfig/isDID']">
            {{ userName }}
            <br />
            {{ user.levelCidi ? `Nivel ${user.levelCidi}` : 'Nivel X' }}
          </span>
          <span v-else>
            {{ userName }}
          </span>
          <v-icon right>mdi-chevron-down</v-icon>
        </v-btn>
      </template>
      <v-card>
        <v-list-item-content class="justify-center">
          <div class="mx-auto px-3">
            <template v-if="$store.getters['authconfig/isDID']">
              <v-btn
                v-if="
                  !userVerified &&
                  !$route.fullPath.includes('/complete-data') &&
                  $store.state.loggedIn
                "
                text
                small
                class="my-2 text-none font-poppins justify-start"
                width="100%"
                data-test="completeRegister"
                :to="
                  user.email && !userHavePublicAddress
                    ? '/complete-data?step=3'
                    : '/complete-data?step=2'
                "
              >
                <v-icon left>mdi-account</v-icon>
                {{ $t('completeRegister') }}
              </v-btn>
              <v-btn
                v-if="userVerified"
                text
                small
                class="my-2 text-none font-poppins justify-start"
                width="100%"
                data-test="digitalIdentity"
                @click="getIdReferenceFromDigitalIdentity"
              >
                <v-icon left>mdi-account-outline</v-icon>
                Identidad Digital
              </v-btn>
              <v-spacer></v-spacer>
              <v-btn
                v-if="userVerified"
                text
                small
                class="my-2 text-none font-poppins justify-start"
                width="100%"
                data-test="wallet"
                to="/citizen/certificates"
              >
                <v-icon left>mdi-wallet-outline</v-icon>
                Portadocumentos
              </v-btn>
              <v-btn
                v-if="user.levelCidi < 2 && user.public_address"
                small
                class="my-2 text-none font-poppins justify-start white--text"
                :style="{
                  background: $store.getters['brand/getHeroPrimaryColor'],
                  'background-image': `linear-gradient(180deg, ${$store.getters['brand/getHeroPrimaryColor']} 0%, ${$store.getters['brand/getHeroSecondaryColor']} 100%)`,
                }"
                width="100%"
                to="/validateCiDiLevel"
              >
                <v-icon color="white" left>mdi-arrow-up-circle-outline</v-icon>
                <span color="white">Subir de Nivel</span>
              </v-btn>
              <v-btn
                v-if="user.type && user.type === 'superadmin'"
                text
                small
                class="my-2 text-none font-poppins justify-start"
                width="100%"
                to="/admin/configuration/users-manager"
              >
                <v-icon color="black" left>mdi-account-edit</v-icon>
                <span color="white">Usuarios</span>
              </v-btn>
              <v-spacer></v-spacer>
              <v-btn
                v-if="user.type && user.type === 'superadmin'"
                text
                small
                class="my-2 text-none font-poppins justify-start"
                width="100%"
                to="/admin/forms/list"
              >
                <v-icon left>mdi-form-select</v-icon>
                Crear Tramite
              </v-btn>

              <!-- <v-spacer></v-spacer>
            <v-btn
              v-if="userVerified"
              text
              small
              class="my-2 text-none font-poppins justify-start"
              width="100%"
              to="/procedures"
            >
              <v-icon left>mdi-clipboard-text-outline</v-icon>
              Mis Trámites
            </v-btn> -->
              <v-divider v-if="userVerified"></v-divider>
            </template>
            <v-btn
              text
              small
              width="100%"
              class="my-2 text-none font-poppins justify-start"
              data-test="logout"
              @click="logoutIf"
            >
              <v-icon left color="red">mdi-power</v-icon>
              Cerrar Sesión
            </v-btn>
          </div>
        </v-list-item-content>
      </v-card>
    </v-menu>

    <v-snackbar
      v-model="snackbar.show"
      :top="true"
      :right="true"
      :timeout="snackbar.timeout"
      :color="snackbar.color"
      :multi-line="snackbar.mode === 'multi-line'"
      :vertical="snackbar.mode === 'vertical'"
    >
      {{ snackbar.text }}
      <v-btn
        icon
        class="float-right"
        justify="center"
        align="center"
        @click.native="snackbar.show = false"
      >
        <v-icon>mdi-close</v-icon>
      </v-btn>
    </v-snackbar>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'
import axios from 'axios'
import { mapGetters } from 'vuex'
import { logOut } from '~/services/Firebase'
import { getIdReferenceFromDigitalIdentity } from '~/services/Certificates'

export default Vue.extend({
  name: 'AvatarMenu',
  props: {
    withPadding: {
      type: Boolean,
      default() {
        return false
      },
    },
  },
  data() {
    return {
      id_reference: '',
      userIsRegistered: false,
      userHavePublicAddress: false,
      logoutLoading: false,
      snackbar: {
        show: false,
        color: '',
        mode: '',
        timeout: 6000,
        text: '',
        right: '',
        top: '',
      },
    }
  },
  computed: {
    ...mapGetters({
      user: 'users/user',
    }),
    userVerified(): boolean {
      return this.userIsRegistered && this.userHavePublicAddress
    },
    userName(): string {
      let userName =
        this.user?.first_name?.split(' ')[0] + ' ' + this.user?.last_name

      if (userName.length > 20) {
        userName = userName.slice(0, 18) + '...'
      }
      return userName
    },
  },
  watch: {
    user(val): any {
      if (val.uid) {
        this.verifyUserRegistration(val.uid)
      }
    },
  },
  async mounted() {
    if (this.user?.uid) {
      await this.verifyUserRegistration(this.user.uid)
    }
  },
  methods: {
    async getIdReferenceFromDigitalIdentity() {
      if (this.user?.uid) {
        const idReference = await getIdReferenceFromDigitalIdentity(
          this.$fire,
          this.user.uid
        )
        this.id_reference = idReference?.docs[0]
          ?.data()
          ?.link.split('/')
          .slice(-1)
        if (this.id_reference) {
          this.$router.push({
            path: `/citizen/certificates/digital-identity/${this.id_reference}`,
          })
        } else {
          this.$router.push({
            path: '/citizen/certificates/digital-identity/',
          })
        }
      }
    },
    logoutIf() {
      if (this.$route.path !== '/complete-data') {
        this.logout()
      } else {
        this.$router.push({ path: '/' })
        this.$root.$on('logout', (valor: boolean) => {
          if (valor) {
            this.logout()
          }
        })
      }
    },
    async logout() {
      try {
        const self = this
        this.logoutLoading = true
        await logOut(this.$fire)
        const reino = localStorage.getItem('reino')
        if (reino) {
          await self.$autenticar.logout()
          localStorage.removeItem('reino')
          localStorage.removeItem('cuit')
          localStorage.removeItem('backToReino')
          localStorage.removeItem('levelUpdated')
        }
        this.$emit('close-drawer', false)
        this.$store.dispatch('users/fetchUser')
        this.$store.dispatch('setloggedIn', false)
        if (this.$route.path !== '/complete-data') {
          this.$router.push({ path: '/' })
        }
        this.logoutLoading = false
      } catch (error) {
        console.error(error)
        this.logoutLoading = false
        this.snackbar.show = true
        this.snackbar.text = 'Ocurrió un error al cerrar sesión'
        this.snackbar.color = 'error'
      }
    },
    async verifyUserRegistration(uid: string) {
      if (this.user?.uid) {
        try {
          const resp = await axios.post(
            `${process.env.OSCITY_ENDPOINTS_URL}/userEmailExist`,
            {
              uid,
            }
          )

          const email = resp.data.user.email
          const emailValidation = email !== null && email !== ''
          const providerValidation = resp.data.user.providerData.length > 0
          this.userIsRegistered = emailValidation && providerValidation
        } catch {
          this.userIsRegistered = false
        }
      }
      if (this.user.public_address) {
        this.userHavePublicAddress = true
      } else {
        this.userHavePublicAddress = false
      }
    },
  },
})
</script>

<style></style>
